library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
package my_package is

--constant N: integer := 12;
--constant logN: integer := 4;
--constant number: std_logic_vector(logN downto 0) := conv_std_logic_vector(n, logN+1);
--constant module: std_logic_vector(N+1 downto 0) := conv_std_logic_vector(239, N+2); --239 mod 4 = 3
--constant two_module: std_logic_vector(N+1 downto 0) := conv_std_logic_vector(478, N+2);
--constant minus_module: std_logic_vector(N+1 downto 0) := conv_std_logic_vector(785, N+2);

constant N: integer := 163;
constant logN: integer := 9;
constant f: std_logic_vector(n-1 downto 0) := 

--conv_std_logic_vector(201, 163);

"00000000000000000000000000000000000000000000000000000000000000000"
&"0000000000000000000000000000000000000000000000000000000000000000"
&"0000000000000000000000000011001001";
constant f_div_x: std_logic_vector(n-1 downto 0) := 

--'1'&conv_std_logic_vector(100, 162);

"100000000000000000000000000000000000000000000000000000000000000000"
&"0000000000000000000000000000000000000000000000000000000000000000"
&"000000000000000000000000001100100";
constant n_minus_1: std_logic_vector(logN downto 0) := conv_std_logic_vector(n-1, logN+1);
end my_package;

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
entity AB_cell is
port (
a, b, den: in STD_LOGIC_VECTOR (N-1 downto 0);
oper_a, msb_a, first_step: in std_logic;
new_a, new_b: out STD_LOGIC_VECTOR (N-1 downto 0)
);
end AB_cell;

architecture rtl of AB_cell is

signal sum: std_logic_vector(n-2 downto 0);

begin

adder: for i in 0 to n-2 generate
sum(i) <= a(i+1) xor (oper_a and b(i+1));
end generate;

mux_1: for i in 0 to n-2 generate
with first_step select new_a(i) <= den(i) when '1', sum(i) when others;
end generate;
with first_step select new_a(n-1) <= den(n-1) when '1', msb_a when others;

with first_step select new_b <= a when '0', f when others;

end rtl;
